## ros-melodic-ubiquity-motor 0.10.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ubiquity_motor)

set(CMAKE_CXX_STANDARD 14) # use C++14

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS 
	roscpp 
	geometry_msgs  
	std_msgs  
	nav_msgs 
	serial 
	hardware_interface 
	controller_manager
	diagnostic_updater
	dynamic_reconfigure)
## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS
	thread
	atomic)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
generate_dynamic_reconfigure_options(
  cfg/PID.cfg
)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/groovy/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

#######################################
## Declare ROS messages and services ##
#######################################

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Leds.msg
# )

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate added messages and services with any dependencies listed here
# generate_messages(
#   DEPENDENCIES
#   std_msgs  # Or other packages containing msgs
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
#  LIBRARIES ubiquity_motor
#  CATKIN_DEPENDS other_catkin_pkg
#  DEPENDS system_lib
)

###########
## Build ##
###########
   	
## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

## Declare a cpp library
add_library(ubiquity_motor
  src/motor_message.cc src/motor_serial.cc src/motor_hardware.cc
)
target_link_libraries(ubiquity_motor
 ${catkin_LIBRARIES}
 ${Boost_LIBRARIES}
)

## Declare a cpp executable
add_executable(motor_node src/motor_node.cc)
add_dependencies(motor_node ${PROJECT_NAME}_gencfg)
target_link_libraries(motor_node
 ubiquity_motor
 ${catkin_LIBRARIES}
 ${Boost_LIBRARIES}
)

add_executable(probe_robot src/probe_robot.cc)
target_link_libraries(probe_robot
 ubiquity_motor
 ${catkin_LIBRARIES}
 ${Boost_LIBRARIES}
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
#add_dependencies(controller)

## Specify libraries to link a library or executable target against
#target_link_libraries(motor_node
 # ${catkin_LIBRARIES}
#)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/groovy/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
install(PROGRAMS
  scripts/upgrade_firmware.py
  scripts/test_motor_board.py
  scripts/test_pi_gpio.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark executables and/or libraries for installation
install(TARGETS ubiquity_motor motor_node probe_robot
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
# install(FILES
#   # myfile1
#   # myfile2
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
if(CATKIN_ENABLE_TESTING)
	find_package(rostest REQUIRED)

	catkin_add_gtest(motor_message_test 
		test/motor_message_test.cc)
	target_link_libraries(motor_message_test ubiquity_motor ${catkin_LIBRARIES})

	catkin_add_gtest(motor_serial_test 
		test/motor_serial_test.cc)
	target_link_libraries(motor_serial_test ubiquity_motor util ${catkin_LIBRARIES})

	catkin_add_gtest(shared_queue_test 
		test/shared_queue_test.cc)
	target_link_libraries(shared_queue_test ubiquity_motor ${catkin_LIBRARIES})

	add_rostest_gtest(motor_param_test 
		test/rostest/motor_parameters.test 
		test/motor_parameter_test.cc )
	target_link_libraries(motor_param_test ubiquity_motor ${catkin_LIBRARIES})

	add_rostest_gtest(motor_hardware_test 
		test/rostest/motor_hardware.test 
		test/motor_hardware_test.cc )
	target_link_libraries(motor_hardware_test ubiquity_motor util ${catkin_LIBRARIES})

endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-melodic-ubiquity-motor (0.10.0-1bionic) bionic; urgency=high

  * Support for higher resolution odometry (firmware v35+ required)
  * Tool to verify odometry consistency
  * Support for target velocity term in the PID (firmware v35+ required)
  * Firmware update script now supports local firmware files
  * Firmware update script can use different serial port
  * Support for reading motor controller version from I2C
  * Safer E-STOP behavior (MCB 5.0+)
  * Publishing the state of the estop switch
  * Improved documentation
  * Improvements to the testing scripts
  * Contributors: Alexander Sergeenko, David Crawley, Mark Johnston, Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sun, 10 Nov 2019 06:00:00 -0000

ros-melodic-ubiquity-motor (0.9.0-1bionic) bionic; urgency=high

  * Allow selecting what firmware version to download
  * Adding max motor forward and reverse speeds and max pwm settings all the way from ROS parameters to being pushed to the controller board.
  * Analyze information to create diagnostics statuses
  * Major update to test_motor_board.py that accepts greatly improved parameter read and set as well as ability to specify com port device to be used
  * Adds support for set of hw rev and for pre rev 5.0 estop threshold
  * Contributors: Mark Johnston, Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Wed, 03 Apr 2019 05:00:00 -0000

ros-melodic-ubiquity-motor (0.8.0-1bionic) bionic; urgency=high

  * Added firmware loading tool
  * Added misc testing scripts
  * Don't die when communication not working, only print error
  * Use std mutex/atomic instead of boost
  * Reduce print level on integral/pid limits
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Tue, 01 Jan 2019 06:00:00 -0000

ros-melodic-ubiquity-motor (0.7.1-1bionic) bionic; urgency=high

  * new pid params
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 16 Jun 2018 05:00:00 -0000

ros-melodic-ubiquity-motor (0.7.0-1bionic) bionic; urgency=high

  * Add script to probe the robot for information
  * Add Serial Protocol Documentation
    Fixes #33 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/33>
  * Add ROS API documentation (#32 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/32>)
    * Add API documentation
    * Remove unused serial_loop_rate variable
  * Contributors: Jim Vaughan, Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sun, 15 Apr 2018 05:00:00 -0000

ros-melodic-ubiquity-motor (0.6.1-1bionic) bionic; urgency=high

  * Reset controller when time jumps (#31 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/31>)
    Reset the controller and zero commanded velocity an unexpected time change occurs (such as by NTP).  This prevents unexpected robot motion.
  * Contributors: Jim Vaughan, Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sun, 12 Nov 2017 06:00:00 -0000

ros-melodic-ubiquity-motor (0.6.0-1bionic) bionic; urgency=high

  * Publish battery voltage messages (#29 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/29>)
    Added battery status message calibrated on 4.4 board serial no 450
  * Contributors: Jim Vaughan, Rohan Agrawal, David Crawley

 -- Rohan Agrawal <rohan@aleopile.com>  Fri, 15 Sep 2017 05:00:00 -0000

ros-melodic-ubiquity-motor (0.5.2-1bionic) bionic; urgency=high

  * Remove debug topics (#25 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/25>)
    * Remove debug topics
    * Remove tests of debug registers
  * Merge pull request #22 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/22> from UbiquityRobotics/suppresserrorsatstartup
    Supress some potentially confusing warnings
  * Increase error_threshold
  * Merge pull request #23 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/23> from UbiquityRobotics/fix_acceleration_limits
    Fix computaion of elapsed time so that it is +ve
  * Fix computaion of elapsed time so that it is +ve
  * Supress some potentially confusing warnings
  * Clean out serial loop (#20 <https://github.com/UbiquityRobotics/ubiquity_motor/issues/20>)
    * Transmit the the same thread caller, not in serial thread
    * go back to debug on tranmissions
    * Use smarter waits and reads in reading thread
    * Get rid of serial loop rate
    * Reformat
  * Contributors: Jim Vaughan, Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 06 May 2017 05:00:00 -0000

ros-melodic-ubiquity-motor (0.5.1-1bionic) bionic; urgency=high

  * Reduce flakey-ness of the tests
  * Try to get firmware version, throw after 10 tries
  * Code cleanup
  * Use fixed sized arrays (not vectors) where they make sense
  * Use a seperate shared_queue class
  * Performance improvements
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 04 Mar 2017 06:00:00 -0000

ros-melodic-ubiquity-motor (0.5.0-1bionic) bionic; urgency=high

  * **NOTE:** This version drops support for firmware versions before 24
  * Use new 8-byte serial protocol
  * Add support for using dynamic_reconfigure to change PID parameters
  * Add support for setting the deadman timer via a parameter
  * Add support for debug registers, do enable better firmware diagnostics
  * Add support for limit reached warnings from firmware
  * Improved testing, more coverage and cleaner tests
  * Have motor_node explicitly return an exit code
  * Reduce memory allocations caused by resizing vectors
  * Use size_t instead of int for iterating
  * Contributors: Rohan Agrawal, Jim Vaughan

 -- Rohan Agrawal <rohan@aleopile.com>  Sun, 04 Sep 2016 05:00:00 -0000

ros-melodic-ubiquity-motor (0.4.1-1bionic) bionic; urgency=high

  * add support for firmware version 19
  * add support for 0xDD (checksum) error response
  * Make variable name for rejected bytes 'rejected'
  * Reduce memcopy-ing
  * Contributors: Rohan Agrawal

 -- Rohan Agrawal <rohan@aleopile.com>  Sat, 09 Apr 2016 05:00:00 -0000



=== debian/control ===
Source: ros-melodic-ubiquity-motor
Section: misc
Priority: optional
Maintainer: Rohan Agrawal <rohan@aleopile.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-controller-manager, ros-melodic-diagnostic-updater, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-hardware-interface, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-serial, ros-melodic-std-msgs, ros-melodic-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ubiquity-motor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-requests, ros-melodic-controller-manager, ros-melodic-diagnostic-updater, ros-melodic-diff-drive-controller, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-hardware-interface, ros-melodic-joint-state-controller, ros-melodic-nav-msgs, ros-melodic-serial, ros-melodic-std-msgs, ros-melodic-tf
Description: Provides a ROS interface to Ubiquity Robotics Magni motor controllers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ubiquity-motor//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
